import { CategorySeries } from "./CategorySeries";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { ITrendLineSeries } from "./ITrendLineSeries";
import { IAnchoredCategorySeriesInteractionManager } from "./IAnchoredCategorySeriesInteractionManager";
import { Type, Point } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { TrendLineType } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { PenLineCap } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { ICategoryScaler } from "./ICategoryScaler";
import { IScaler } from "./IScaler";
import { IBucketizer } from "./IBucketizer";
import { CategorySeriesView } from "./CategorySeriesView";
import { IPreparesCategoryTrendline } from "./IPreparesCategoryTrendline";
import { CategorySeriesMarkerCollisionAvoidance } from "./CategorySeriesMarkerCollisionAvoidance";
import { ConsolidatedItemHitTestBehavior } from "./ConsolidatedItemHitTestBehavior";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { Axis } from "./Axis";
import { ITrendLineManager } from "./ITrendLineManager";
import { CategoryBucketCalculator } from "./CategoryBucketCalculator";
import { AxisRange } from "./AxisRange";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { Clipper } from "igniteui-react-core";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { RenderSurface } from "./RenderSurface";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { ValueLayerValueMode } from "./ValueLayerValueMode";
import { RenderingContext } from "igniteui-react-core";
/**
 * @hidden
 */
export declare abstract class AnchoredCategorySeries extends CategorySeries implements IIsCategoryBased, IHasSingleValueCategory, IHasCategoryTrendline, ITrendLineSeries {
    static $t: Type;
    private xl;
    get xm(): IAnchoredCategorySeriesInteractionManager;
    xh: AnchoredCategorySeriesView;
    getHostReferenceValue(): number;
    k0(): string;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    xq: boolean;
    constructor();
    x7: string;
    jv(a: any, b: string): any;
    get valueColumn(): IFastItemColumn$1<number>;
    set valueColumn(a: IFastItemColumn$1<number>);
    private xn;
    xz: string;
    x3: string;
    x5: string;
    getDataLegendSeriesContextAt(a: number, b: number): any;
    trendLineType: TrendLineType;
    trendLineBrush: Brush;
    get yu(): Brush;
    set yu(a: Brush);
    static readonly yg: DependencyProperty;
    trendLineThickness: number;
    yw: PenLineCap;
    yv: DoubleCollection;
    trendLinePeriod: number;
    xu: number;
    fp(a: any): boolean;
    protected xe(a: number, b: number, c: Axis): any[];
    protected pa(a: any, b: string, c: any, d: any): void;
    aq(a: Axis): AxisRange;
    protected np(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected wo(): number;
    xt(a: CategorySeriesView): number;
    yd(a: PointCollection, b: number, c: CategorySeriesView): void;
    xf(a: List$1<number[]>, b: number, c: Rect, d: Rect): Clipper;
    xg(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    protected fo(): boolean;
    protected g1(): List$1<SeriesLayerPropertyOverlay>;
    private x9;
    gm(a: Rect, b: Rect, c: SeriesView): boolean;
    nk(a: boolean, b: SeriesView): void;
    w4(a: CategoryFrame, b: CategorySeriesView): void;
    w7(a: CategoryFrame, b: CategorySeriesView): void;
    xi: CategoryFrame;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    ya(a: CategoryFrame, b: CategorySeriesView): void;
    protected qf(): void;
    jz(a: any, b: Point): any;
    get currentCategoryMode(): CategoryMode;
    get scaler(): ICategoryScaler;
    get yScaler(): IScaler;
    get bucketizer(): IBucketizer;
    get currentMode2Index(): number;
    provideCollisionDetector(): IDetectsCollisions;
    get trendlinePreparer(): IPreparesCategoryTrendline;
    protected xx: string;
    protected xw: string;
    abstract yb(a: Axis): void;
    abstract yc(a: Axis): void;
    protected n2(a: any): void;
    xj: CategorySeriesMarkerCollisionAvoidance;
    js(a: Point): any;
    xk: ConsolidatedItemHitTestBehavior;
    get mayContainUnknowns(): boolean;
    h3(): number;
    protected get_xv(): number;
    protected get xv(): number;
    ar(a: Rect): AxisRange;
    private yf;
    private xp;
    private xr;
    xs: number;
    private ye;
    id(a: ValueLayerValueMode, b: Axis): number;
    am(a: ValueLayerValueMode): number[];
    tm(a: ValueLayerValueMode): Point;
    tn(a: number[]): Point;
    get useHighMarkerFidelity(): boolean;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class AnchoredCategoryBucketCalculator extends CategoryBucketCalculator {
    static $t: Type;
    constructor(a: AnchoredCategorySeriesView);
    protected i: AnchoredCategorySeriesView;
    getBucketWithoutUnknowns(a: number): number[];
    getBucket(a: number): number[];
    private h;
    private j;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare class AnchoredCategorySeriesView extends CategorySeriesView {
    static $t: Type;
    c3: AnchoredCategorySeries;
    constructor(a: AnchoredCategorySeries);
    private c4;
    get c5(): ITrendLineManager;
    set c5(a: ITrendLineManager);
    get c6(): boolean;
    da(): void;
    c8(): void;
    c7(): void;
    cv(): CategoryBucketCalculator;
    c9(): void;
    db(): void;
    dc(a: number): Rect;
    protected a7(a: RenderingContext, b: boolean): void;
    getDefaultTooltipTemplate(): string;
}
